Index: kernel/generic/src/ddi/irq.c
===================================================================
--- kernel/generic/src/ddi/irq.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/ddi/irq.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -32,9 +32,34 @@
 /**
  * @file
- * @brief IRQ dispatcher
- *
- * This file provides means of connecting IRQs with respective device drivers
- * and logic for dispatching interrupts to IRQ handlers defined by those
- * drivers.
+ * @brief IRQ dispatcher.
+ *
+ * This file provides means of connecting IRQs with particular devices and logic
+ * for dispatching interrupts to IRQ handlers defined by those devices.
+ *
+ * This code is designed to support:
+ * - multiple devices sharing single IRQ
+ * - multiple IRQs per single device
+ * - multiple instances of the same device
+ *
+ *
+ * Note about architectures.
+ *
+ * Some architectures have the term IRQ well defined. Examples of such
+ * architectures include amd64, ia32 and mips32. Some other architectures, such
+ * as sparc64, don't use the term at all. In those cases, we boldly step forward
+ * and define what an IRQ is.
+ *
+ * The implementation is generic enough and still allows the architectures to
+ * use the hardware layout effectively.  For instance, on amd64 and ia32, where
+ * there is only 16 IRQs, the irq_hash_table can be optimized to a
+ * one-dimensional array. Next, when it is known that the IRQ numbers (aka
+ * INR's) are unique, the claim functions can always return IRQ_ACCEPT.
+ *
+ *
+ * Note about the irq_hash_table.
+ *
+ * The hash table is configured to use two keys: inr and devno.  However, the
+ * hash index is computed only from inr. Moreover, if devno is -1, the match is
+ * based on the return value of the claim() function instead of on devno.
  */
 
@@ -49,7 +74,8 @@
 #include <arch.h>
 
-slab_cache_t *irq_slab = NULL;
-
-/** Spinlock protecting the kernel IRQ hash table
+#define KEY_INR    0
+#define KEY_DEVNO  1
+
+/** Spinlock protecting the kernel IRQ hash table.
  *
  * This lock must be taken only when interrupts are disabled.
@@ -61,5 +87,5 @@
 static hash_table_t irq_kernel_hash_table;
 
-/** Spinlock protecting the uspace IRQ hash table
+/** Spinlock protecting the uspace IRQ hash table.
  *
  * This lock must be taken only when interrupts are disabled.
@@ -68,7 +94,11 @@
 IRQ_SPINLOCK_INITIALIZE(irq_uspace_hash_table_lock);
 
-/** The uspace IRQ hash table */
+/** The uspace IRQ hash table. */
 hash_table_t irq_uspace_hash_table;
 
+/**
+ * Hash table operations for cases when we know that there will be collisions
+ * between different keys.
+ */
 static size_t irq_ht_hash(sysarg_t *key);
 static bool irq_ht_compare(sysarg_t *key, size_t keys, link_t *item);
@@ -81,14 +111,29 @@
 };
 
-/** Number of buckets in either of the hash tables */
+/**
+ * Hash table operations for cases when we know that there will be no collisions
+ * between different keys.  However, there might be still collisions among
+ * elements with single key (sharing of one IRQ).
+ */
+static size_t irq_lin_hash(sysarg_t *key);
+static bool irq_lin_compare(sysarg_t *key, size_t keys, link_t *item);
+static void irq_lin_remove(link_t *item);
+
+static hash_table_operations_t irq_lin_ops = {
+	.hash = irq_lin_hash,
+	.compare = irq_lin_compare,
+	.remove_callback = irq_lin_remove,
+};
+
+/** Number of buckets in either of the hash tables. */
 static size_t buckets;
 
-/** Last valid INR */
+/** Last valid INR. */
 inr_t last_inr = 0;
 
-/** Initialize IRQ subsystem
- *
- * @param inrs    Numbers of unique IRQ numbers or INRs.
- * @param chains  Number of buckets in the hash table.
+/** Initialize IRQ subsystem.
+ *
+ * @param inrs   Numbers of unique IRQ numbers or INRs.
+ * @param chains Number of chains in the hash table.
  *
  */
@@ -98,15 +143,26 @@
 	last_inr = inrs - 1;
 
-	irq_slab = slab_cache_create("irq_t", sizeof(irq_t), 0, NULL, NULL,
-	    FRAME_ATOMIC);
-	assert(irq_slab);
-
-	hash_table_create(&irq_uspace_hash_table, chains, 2, &irq_ht_ops);
-	hash_table_create(&irq_kernel_hash_table, chains, 2, &irq_ht_ops);
-}
-
-/** Initialize one IRQ structure
- *
- * @param irq  Pointer to the IRQ structure to be initialized.
+	/*
+	 * Be smart about the choice of the hash table operations.  In cases in
+	 * which inrs equals the requested number of chains (i.e. where there is
+	 * no collision between different keys), we can use optimized set of
+	 * operations.
+	 */
+	if (inrs == chains) {
+		hash_table_create(&irq_uspace_hash_table, chains, 2,
+		    &irq_lin_ops);
+		hash_table_create(&irq_kernel_hash_table, chains, 2,
+		    &irq_lin_ops);
+	} else {
+		hash_table_create(&irq_uspace_hash_table, chains, 2,
+		    &irq_ht_ops);
+		hash_table_create(&irq_kernel_hash_table, chains, 2,
+		    &irq_ht_ops);
+	}
+}
+
+/** Initialize one IRQ structure.
+ *
+ * @param irq Pointer to the IRQ structure to be initialized.
  *
  */
@@ -116,15 +172,17 @@
 	link_initialize(&irq->link);
 	irq_spinlock_initialize(&irq->lock, "irq.lock");
+	link_initialize(&irq->notif_cfg.link);
 	irq->inr = -1;
+	irq->devno = -1;
 	
 	irq_initialize_arch(irq);
 }
 
-/** Register IRQ for device
+/** Register IRQ for device.
  *
  * The irq structure must be filled with information about the interrupt source
  * and with the claim() function pointer and handler() function pointer.
  *
- * @param irq  IRQ structure belonging to a device.
+ * @param irq IRQ structure belonging to a device.
  *
  */
@@ -132,6 +190,6 @@
 {
 	sysarg_t key[] = {
-		[IRQ_HT_KEY_INR] = (sysarg_t) irq->inr,
-		[IRQ_HT_KEY_MODE] = (sysarg_t) IRQ_HT_MODE_NO_CLAIM 
+		(sysarg_t) irq->inr,
+		(sysarg_t) irq->devno
 	};
 	
@@ -143,11 +201,13 @@
 }
 
-/** Search and lock the uspace IRQ hash table */
+/** Search and lock the uspace IRQ hash table.
+ *
+ */
 static irq_t *irq_dispatch_and_lock_uspace(inr_t inr)
 {
 	link_t *lnk;
 	sysarg_t key[] = {
-		[IRQ_HT_KEY_INR] = (sysarg_t) inr,
-		[IRQ_HT_KEY_MODE] = (sysarg_t) IRQ_HT_MODE_CLAIM
+		(sysarg_t) inr,
+		(sysarg_t) -1    /* Search will use claim() instead of devno */
 	};
 	
@@ -164,11 +224,13 @@
 }
 
-/** Search and lock the kernel IRQ hash table */
+/** Search and lock the kernel IRQ hash table.
+ *
+ */
 static irq_t *irq_dispatch_and_lock_kernel(inr_t inr)
 {
 	link_t *lnk;
 	sysarg_t key[] = {
-		[IRQ_HT_KEY_INR] = (sysarg_t) inr,
-		[IRQ_HT_KEY_MODE] = (sysarg_t) IRQ_HT_MODE_CLAIM
+		(sysarg_t) inr,
+		(sysarg_t) -1    /* Search will use claim() instead of devno */
 	};
 	
@@ -185,5 +247,5 @@
 }
 
-/** Dispatch the IRQ
+/** Dispatch the IRQ.
  *
  * We assume this function is only called from interrupt context (i.e. that
@@ -193,5 +255,5 @@
  * return with interrupts disabled and holding the respective structure.
  *
- * @param inr  Interrupt number (aka inr or irq).
+ * @param inr Interrupt number (aka inr or irq).
  *
  * @return IRQ structure of the respective device
@@ -223,8 +285,12 @@
 }
 
-/** Compute hash index for the key
- *
- * @param key  The first of the keys is inr and the second is mode. Only inr is
- *             used to compute the hash.
+/** Compute hash index for the key.
+ *
+ * This function computes hash index into the IRQ hash table for which there can
+ * be collisions between different INRs.
+ *
+ * The devno is not used to compute the hash.
+ *
+ * @param key The first of the keys is inr and the second is devno or -1.
  *
  * @return Index into the hash table.
@@ -233,21 +299,25 @@
 size_t irq_ht_hash(sysarg_t key[])
 {
-	inr_t inr = (inr_t) key[IRQ_HT_KEY_INR];
+	inr_t inr = (inr_t) key[KEY_INR];
 	return inr % buckets;
 }
 
-/** Compare hash table element with a key
- *
- * If mode is IRQ_HT_MODE_CLAIM, the result of the claim() function is used for
- * the match. Otherwise the key does not match.
+/** Compare hash table element with a key.
+ *
+ * There are two things to note about this function.  First, it is used for the
+ * more complex architecture setup in which there are way too many interrupt
+ * numbers (i.e. inr's) to arrange the hash table so that collisions occur only
+ * among same inrs of different devnos. So the explicit check for inr match must
+ * be done.  Second, if devno is -1, the second key (i.e. devno) is not used for
+ * the match and the result of the claim() function is used instead.
  *
  * This function assumes interrupts are already disabled.
  *
- * @param key   Keys (i.e. inr and mode).
- * @param keys  This is 2. 
- * @param item  The item to compare the key with.
- *
- * @return True on match
- * @return False on no match
+ * @param key  Keys (i.e. inr and devno).
+ * @param keys This is 2. 
+ * @param item The item to compare the key with.
+ *
+ * @return true on match
+ * @return false on no match
  *
  */
@@ -255,16 +325,17 @@
 {
 	irq_t *irq = hash_table_get_instance(item, irq_t, link);
-	inr_t inr = (inr_t) key[IRQ_HT_KEY_INR];
-	irq_ht_mode_t mode = (irq_ht_mode_t) key[IRQ_HT_KEY_MODE];
+	inr_t inr = (inr_t) key[KEY_INR];
+	devno_t devno = (devno_t) key[KEY_DEVNO];
 	
 	bool rv;
 	
 	irq_spinlock_lock(&irq->lock, false);
-	if (mode == IRQ_HT_MODE_CLAIM) {
+	if (devno == -1) {
 		/* Invoked by irq_dispatch_and_lock(). */
-		rv = ((irq->inr == inr) && (irq->claim(irq) == IRQ_ACCEPT));
+		rv = ((irq->inr == inr) &&
+		    (irq->claim(irq) == IRQ_ACCEPT));
 	} else {
 		/* Invoked by irq_find_and_lock(). */
-		rv = false;
+		rv = ((irq->inr == inr) && (irq->devno == devno));
 	}
 	
@@ -276,7 +347,7 @@
 }
 
-/** Unlock IRQ structure after hash_table_remove()
- *
- * @param lnk  Link in the removed and locked IRQ structure.
+/** Unlock IRQ structure after hash_table_remove().
+ *
+ * @param lnk Link in the removed and locked IRQ structure.
  */
 void irq_ht_remove(link_t *lnk)
@@ -287,4 +358,73 @@
 }
 
+/** Compute hash index for the key.
+ *
+ * This function computes hash index into the IRQ hash table for which there are
+ * no collisions between different INRs.
+ *
+ * @param key The first of the keys is inr and the second is devno or -1.
+ *
+ * @return Index into the hash table.
+ *
+ */
+size_t irq_lin_hash(sysarg_t key[])
+{
+	inr_t inr = (inr_t) key[KEY_INR];
+	return inr;
+}
+
+/** Compare hash table element with a key.
+ *
+ * There are two things to note about this function.  First, it is used for the
+ * less complex architecture setup in which there are not too many interrupt
+ * numbers (i.e. inr's) to arrange the hash table so that collisions occur only
+ * among same inrs of different devnos. So the explicit check for inr match is
+ * not done.  Second, if devno is -1, the second key (i.e. devno) is not used
+ * for the match and the result of the claim() function is used instead.
+ *
+ * This function assumes interrupts are already disabled.
+ *
+ * @param key  Keys (i.e. inr and devno).
+ * @param keys This is 2. 
+ * @param item The item to compare the key with.
+ *
+ * @return true on match
+ * @return false on no match
+ *
+ */
+bool irq_lin_compare(sysarg_t key[], size_t keys, link_t *item)
+{
+	irq_t *irq = list_get_instance(item, irq_t, link);
+	devno_t devno = (devno_t) key[KEY_DEVNO];
+	bool rv;
+	
+	irq_spinlock_lock(&irq->lock, false);
+	if (devno == -1) {
+		/* Invoked by irq_dispatch_and_lock() */
+		rv = (irq->claim(irq) == IRQ_ACCEPT);
+	} else {
+		/* Invoked by irq_find_and_lock() */
+		rv = (irq->devno == devno);
+	}
+	
+	/* unlock only on non-match */
+	if (!rv)
+		irq_spinlock_unlock(&irq->lock, false);
+	
+	return rv;
+}
+
+/** Unlock IRQ structure after hash_table_remove().
+ *
+ * @param lnk Link in the removed and locked IRQ structure.
+ *
+ */
+void irq_lin_remove(link_t *lnk)
+{
+	irq_t *irq __attribute__((unused))
+	    = hash_table_get_instance(lnk, irq_t, link);
+	irq_spinlock_unlock(&irq->lock, false);
+}
+
 /** @}
  */
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/ipc/ipc.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -43,5 +43,4 @@
 #include <synch/waitq.h>
 #include <ipc/ipc.h>
-#include <ipc/ipcrsc.h>
 #include <abi/ipc/methods.h>
 #include <ipc/kbox.h>
@@ -59,5 +58,4 @@
 #include <arch/interrupt.h>
 #include <ipc/irq.h>
-#include <cap/cap.h>
 
 static void ipc_forget_call(call_t *);
@@ -66,8 +64,6 @@
 answerbox_t *ipc_phone_0 = NULL;
 
-static slab_cache_t *call_slab;
-static slab_cache_t *answerbox_slab;
-
-slab_cache_t *phone_slab = NULL; 
+static slab_cache_t *ipc_call_slab;
+static slab_cache_t *ipc_answerbox_slab;
 
 /** Initialize a call structure.
@@ -97,5 +93,5 @@
 		if (call->buffer)
 			free(call->buffer);
-		slab_free(call_slab, call);
+		slab_free(ipc_call_slab, call);
 	}
 }
@@ -114,5 +110,5 @@
 call_t *ipc_call_alloc(unsigned int flags)
 {
-	call_t *call = slab_alloc(call_slab, flags);
+	call_t *call = slab_alloc(ipc_call_slab, flags);
 	if (call) {
 		_ipc_call_init(call);
@@ -149,4 +145,5 @@
 	list_initialize(&box->answers);
 	list_initialize(&box->irq_notifs);
+	list_initialize(&box->irq_list);
 	box->task = task;
 }
@@ -154,9 +151,7 @@
 /** Connect a phone to an answerbox.
  *
- * This function must be passed a reference to phone->kobject.
- *
- * @param phone  Initialized phone structure.
- * @param box    Initialized answerbox structure.
- * @return       True if the phone was connected, false otherwise.
+ * @param phone Initialized phone structure.
+ * @param box   Initialized answerbox structure.
+ * @return      True if the phone was connected, false otherwise.
  */
 bool ipc_phone_connect(phone_t *phone, answerbox_t *box)
@@ -171,5 +166,4 @@
 		phone->state = IPC_PHONE_CONNECTED;
 		phone->callee = box;
-		/* Pass phone->kobject reference to box->connected_phones */
 		list_append(&phone->link, &box->connected_phones);
 	}
@@ -177,9 +171,4 @@
 	irq_spinlock_unlock(&box->lock, true);
 	mutex_unlock(&phone->lock);
-
-	if (!active) {
-		/* We still have phone->kobject's reference; drop it */
-		kobject_put(phone->kobject);
-	}
 
 	return active;
@@ -199,5 +188,4 @@
 	phone->state = IPC_PHONE_FREE;
 	atomic_set(&phone->active_calls, 0);
-	phone->kobject = NULL;
 }
 
@@ -212,5 +200,5 @@
 int ipc_call_sync(phone_t *phone, call_t *request)
 {
-	answerbox_t *mybox = slab_alloc(answerbox_slab, 0);
+	answerbox_t *mybox = slab_alloc(ipc_answerbox_slab, 0);
 	ipc_answerbox_init(mybox, TASK);
 	
@@ -220,5 +208,5 @@
 	int rc = ipc_call(phone, request);
 	if (rc != EOK) {
-		slab_free(answerbox_slab, mybox);
+		slab_free(ipc_answerbox_slab, mybox);
 		return rc;
 	}
@@ -267,5 +255,5 @@
 	assert(!answer || request == answer);
 	
-	slab_free(answerbox_slab, mybox);
+	slab_free(ipc_answerbox_slab, mybox);
 	return rc;
 }
@@ -465,7 +453,4 @@
 		list_remove(&phone->link);
 		irq_spinlock_unlock(&box->lock, true);
-
-		/* Drop the answerbox reference */
-		kobject_put(phone->kobject);
 		
 		call_t *call = ipc_call_alloc(0);
@@ -670,6 +655,4 @@
 
 			task_release(phone->caller);
-
-			kobject_put(phone->kobject);
 			
 			/* Must start again */
@@ -678,5 +661,4 @@
 		
 		mutex_unlock(&phone->lock);
-		kobject_put(phone->kobject);
 	}
 	
@@ -725,5 +707,5 @@
 		 * Nota bene: there may still be answers waiting for pick up.
 		 */
-		spinlock_unlock(&TASK->active_calls_lock);
+		spinlock_unlock(&TASK->active_calls_lock);	
 		return;	
 	}
@@ -738,5 +720,5 @@
 		 * call on the list.
 		 */
-		spinlock_unlock(&TASK->active_calls_lock);
+		spinlock_unlock(&TASK->active_calls_lock);	
 		goto restart;
 	}
@@ -745,50 +727,4 @@
 
 	goto restart;
-}
-
-static bool phone_cap_wait_cb(cap_t *cap, void *arg)
-{
-	phone_t *phone = cap->kobject->phone;
-	bool *restart = (bool *) arg;
-
-	mutex_lock(&phone->lock);
-	if ((phone->state == IPC_PHONE_HUNGUP) &&
-	    (atomic_get(&phone->active_calls) == 0)) {
-		phone->state = IPC_PHONE_FREE;
-		phone->callee = NULL;
-	}
-
-	/*
-	 * We might have had some IPC_PHONE_CONNECTING phones at the beginning
-	 * of ipc_cleanup(). Depending on whether these were forgotten or
-	 * answered, they will eventually enter the IPC_PHONE_FREE or
-	 * IPC_PHONE_CONNECTED states, respectively.  In the latter case, the
-	 * other side may slam the open phones at any time, in which case we
-	 * will get an IPC_PHONE_SLAMMED phone.
-	 */
-	if ((phone->state == IPC_PHONE_CONNECTED) ||
-	    (phone->state == IPC_PHONE_SLAMMED)) {
-		mutex_unlock(&phone->lock);
-		ipc_phone_hangup(phone);
-		/*
-		 * Now there may be one extra active call, which needs to be
-		 * forgotten.
-		 */
-		ipc_forget_all_active_calls();
-		*restart = true;
-		return false;
-	}
-
-	/*
-	 * If the hangup succeeded, it has sent a HANGUP message, the IPC is now
-	 * in HUNGUP state, we wait for the reply to come
-	 */
-	if (phone->state != IPC_PHONE_FREE) {
-		mutex_unlock(&phone->lock);
-		return false;
-	}
-
-	mutex_unlock(&phone->lock);
-	return true;
 }
 
@@ -797,5 +733,5 @@
 {
 	call_t *call;
-	bool restart;
+	size_t i;
 
 restart:
@@ -804,13 +740,51 @@
 	 * Locking is needed as there may be connection handshakes in progress.
 	 */
-	restart = false;
-	if (caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_PHONE,
-	    phone_cap_wait_cb, &restart)) {
-		/* Got into cleanup */
+	for (i = 0; i < IPC_MAX_PHONES; i++) {
+		phone_t *phone = &TASK->phones[i];
+
+		mutex_lock(&phone->lock);	
+		if ((phone->state == IPC_PHONE_HUNGUP) &&
+		    (atomic_get(&phone->active_calls) == 0)) {
+			phone->state = IPC_PHONE_FREE;
+			phone->callee = NULL;
+		}
+
+		/*
+		 * We might have had some IPC_PHONE_CONNECTING phones at the
+		 * beginning of ipc_cleanup(). Depending on whether these were
+		 * forgotten or answered, they will eventually enter the
+		 * IPC_PHONE_FREE or IPC_PHONE_CONNECTED states, respectively.
+		 * In the latter case, the other side may slam the open phones
+		 * at any time, in which case we will get an IPC_PHONE_SLAMMED
+		 * phone.
+		 */
+		if ((phone->state == IPC_PHONE_CONNECTED) ||
+		    (phone->state == IPC_PHONE_SLAMMED)) {
+			mutex_unlock(&phone->lock);
+			ipc_phone_hangup(phone);
+			/*
+			 * Now there may be one extra active call, which needs
+			 * to be forgotten.
+			 */
+			ipc_forget_all_active_calls();
+			goto restart;
+		}
+
+		/*
+		 * If the hangup succeeded, it has sent a HANGUP message, the
+		 * IPC is now in HUNGUP state, we wait for the reply to come
+		 */
+		if (phone->state != IPC_PHONE_FREE) {
+			mutex_unlock(&phone->lock);
+			break;
+		}
+
+		mutex_unlock(&phone->lock);
+	}
+		
+	/* Got into cleanup */
+	if (i == IPC_MAX_PHONES)
 		return;
-	}
-	if (restart)
-		goto restart;
-	
+		
 	call = ipc_wait_for_call(&TASK->answerbox, SYNCH_NO_TIMEOUT,
 	    SYNCH_FLAGS_NONE);
@@ -821,16 +795,4 @@
 	ipc_call_free(call);
 	goto restart;
-}
-
-static bool phone_cap_cleanup_cb(cap_t *cap, void *arg)
-{
-	ipc_phone_hangup(cap->kobject->phone);
-	return true;
-}
-
-static bool irq_cap_cleanup_cb(cap_t *cap, void *arg)
-{
-	ipc_irq_unsubscribe(&TASK->answerbox, cap->handle);
-	return true;
 }
 
@@ -854,13 +816,12 @@
 
 	/* Disconnect all our phones ('ipc_phone_hangup') */
-	caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_PHONE,
-	    phone_cap_cleanup_cb, NULL);
+	for (size_t i = 0; i < IPC_MAX_PHONES; i++)
+		ipc_phone_hangup(&TASK->phones[i]);
 	
 	/* Unsubscribe from any event notifications. */
 	event_cleanup_answerbox(&TASK->answerbox);
 	
-	/* Disconnect all connected IRQs */
-	caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_IRQ, irq_cap_cleanup_cb,
-	    NULL);
+	/* Disconnect all connected irqs */
+	ipc_irq_cleanup(&TASK->answerbox);
 	
 	/* Disconnect all phones connected to our regular answerbox */
@@ -886,10 +847,8 @@
 void ipc_init(void)
 {
-	call_slab = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
+	ipc_call_slab = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
 	    NULL, 0);
-	phone_slab = slab_cache_create("phone_t", sizeof(phone_t), 0, NULL,
-	    NULL, 0);
-	answerbox_slab = slab_cache_create("answerbox_t", sizeof(answerbox_t),
-	    0, NULL, NULL, 0);
+	ipc_answerbox_slab = slab_cache_create("answerbox_t",
+	    sizeof(answerbox_t), 0, NULL, NULL, 0);
 }
 
@@ -926,39 +885,4 @@
 }
 
-static bool print_task_phone_cb(cap_t *cap, void *arg)
-{
-	phone_t *phone = cap->kobject->phone;
-
-	mutex_lock(&phone->lock);
-	if (phone->state != IPC_PHONE_FREE) {
-		printf("%-11d %7" PRIun " ", cap->handle,
-		    atomic_get(&phone->active_calls));
-		
-		switch (phone->state) {
-		case IPC_PHONE_CONNECTING:
-			printf("connecting");
-			break;
-		case IPC_PHONE_CONNECTED:
-			printf("connected to %" PRIu64 " (%s)",
-			    phone->callee->task->taskid,
-			    phone->callee->task->name);
-			break;
-		case IPC_PHONE_SLAMMED:
-			printf("slammed by %p", phone->callee);
-			break;
-		case IPC_PHONE_HUNGUP:
-			printf("hung up by %p", phone->callee);
-			break;
-		default:
-			break;
-		}
-		
-		printf("\n");
-	}
-	mutex_unlock(&phone->lock);
-
-	return true;
-}
-
 /** List answerbox contents.
  *
@@ -970,17 +894,53 @@
 	irq_spinlock_lock(&tasks_lock, true);
 	task_t *task = task_find_by_id(taskid);
+	
 	if (!task) {
 		irq_spinlock_unlock(&tasks_lock, true);
 		return;
 	}
-	task_hold(task);
-	irq_spinlock_unlock(&tasks_lock, true);
-	
-	printf("[phone cap] [calls] [state\n");
-	
-	caps_apply_to_kobject_type(task, KOBJECT_TYPE_PHONE,
-	    print_task_phone_cb, NULL);
-	
-	irq_spinlock_lock(&task->lock, true);
+	
+	/* Hand-over-hand locking */
+	irq_spinlock_exchange(&tasks_lock, &task->lock);
+	
+	printf("[phone id] [calls] [state\n");
+	
+	size_t i;
+	for (i = 0; i < IPC_MAX_PHONES; i++) {
+		if (SYNCH_FAILED(mutex_trylock(&task->phones[i].lock))) {
+			printf("%-10zu (mutex busy)\n", i);
+			continue;
+		}
+		
+		if (task->phones[i].state != IPC_PHONE_FREE) {
+			printf("%-10zu %7" PRIun " ", i,
+			    atomic_get(&task->phones[i].active_calls));
+			
+			switch (task->phones[i].state) {
+			case IPC_PHONE_CONNECTING:
+				printf("connecting");
+				break;
+			case IPC_PHONE_CONNECTED:
+				printf("connected to %" PRIu64 " (%s)",
+				    task->phones[i].callee->task->taskid,
+				    task->phones[i].callee->task->name);
+				break;
+			case IPC_PHONE_SLAMMED:
+				printf("slammed by %p",
+				    task->phones[i].callee);
+				break;
+			case IPC_PHONE_HUNGUP:
+				printf("hung up by %p",
+				    task->phones[i].callee);
+				break;
+			default:
+				break;
+			}
+			
+			printf("\n");
+		}
+		
+		mutex_unlock(&task->phones[i].lock);
+	}
+	
 	irq_spinlock_lock(&task->answerbox.lock, false);
 	
@@ -1004,6 +964,4 @@
 	irq_spinlock_unlock(&task->answerbox.lock, false);
 	irq_spinlock_unlock(&task->lock, true);
-
-	task_release(task);
 }
 
Index: kernel/generic/src/ipc/ipcrsc.c
===================================================================
--- kernel/generic/src/ipc/ipcrsc.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/ipc/ipcrsc.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -39,5 +39,5 @@
  *
  * The pattern of usage of the resources is:
- * - allocate empty phone capability slot, connect | deallocate slot
+ * - allocate empty phone slot, connect | deallocate slot
  * - disconnect connected phone (some messages might be on the fly)
  * - find phone in slot and send a message using phone
@@ -53,5 +53,5 @@
  *   atomic on all platforms)
  *
- * - To find an empty phone capability slot, the TASK must be locked
+ * - To find an empty phone slot, the TASK must be locked
  * - To answer a message, the answerbox must be locked
  * - The locking of phone and answerbox is done at the ipc_ level.
@@ -77,10 +77,10 @@
  *
  * *** Connect_to_me ***
- * The caller sends IPC_M_CONNECT_TO_ME.
+ * The caller sends IPC_M_CONNECT_TO_ME. 
  * The server receives an automatically opened phoneid. If it accepts
- * (RETVAL=0), it can use the phoneid immediately.  Possible race condition can
- * arise, when the client receives messages from new connection before getting
- * response for connect_to_me message. Userspace should implement handshake
- * protocol that would control it.
+ * (RETVAL=0), it can use the phoneid immediately. 
+ * Possible race condition can arise, when the client receives messages from new
+ * connection before getting response for connect_to_me message. Userspace
+ * should implement handshake protocol that would control it.
  *
  * Phone hangup
@@ -89,19 +89,18 @@
  * - The phone is disconnected (no more messages can be sent over this phone),
  *   all in-progress messages are correctly handled. The answerbox receives
- *   IPC_M_PHONE_HUNGUP call from the phone that hung up. When all async calls
- *   are answered, the phone is deallocated.
+ *   IPC_M_PHONE_HUNGUP call from the phone that hung up. When all async
+ *   calls are answered, the phone is deallocated.
  *
  * *** The answerbox hangs up (ipc_answer(EHANGUP))
- * - The phone is disconnected. EHANGUP response code is sent to the calling
- *   task. All new calls through this phone get a EHUNGUP error code, the task
- *   is expected to send an sys_ipc_hangup after cleaning up its internal
- *   structures.
- *
+ * - The phone is disconnected. EHANGUP response code is sent
+ *   to the calling task. All new calls through this phone
+ *   get a EHUNGUP error code, the task is expected to
+ *   send an sys_ipc_hangup after cleaning up its internal structures.
  *
  * Call forwarding
  *
- * The call can be forwarded, so that the answer to call is passed directly to
- * the original sender. However, this poses special problems regarding routing
- * of hangup messages.
+ * The call can be forwarded, so that the answer to call is passed directly
+ * to the original sender. However, this poses special problems regarding 
+ * routing of hangup messages.
  *
  * sys_ipc_hangup -> IPC_M_PHONE_HUNGUP
@@ -134,6 +133,4 @@
 #include <assert.h>
 #include <abi/errno.h>
-#include <cap/cap.h>
-#include <mm/slab.h>
 
 /** Find call_t * in call table according to callid.
@@ -141,8 +138,9 @@
  * @todo Some speedup (hash table?)
  *
- * @param callid Userspace hash of the call. Currently it is the call structure
- *               kernel address.
- *
- * @return NULL on not found, otherwise pointer to the call structure.
+ * @param callid Userspace hash of the call. Currently it is the call
+ *               structure kernel address.
+ *
+ * @return NULL on not found, otherwise pointer to the call
+ *         structure.
  *
  */
@@ -164,63 +162,66 @@
 }
 
-static bool phone_reclaim(kobject_t *kobj)
-{
-	bool gc = false;
-
-	mutex_lock(&kobj->phone->lock);
-	if (kobj->phone->state == IPC_PHONE_HUNGUP &&
-	    atomic_get(&kobj->phone->active_calls) == 0)
-		gc = true;
-	mutex_unlock(&kobj->phone->lock);
-
-	return gc;
-}
-
-static void phone_destroy(void *arg)
-{
-	phone_t *phone = (phone_t *) arg;
-	slab_free(phone_slab, phone);
-}
-
-static kobject_ops_t phone_kobject_ops = {
-	.reclaim = phone_reclaim,
-	.destroy = phone_destroy
-};
-
-
-/** Allocate new phone in the specified task.
- *
- * @param task  Task for which to allocate a new phone.
- *
- * @return  New phone capability handle.
- * @return  Negative error code if a new capability cannot be allocated.
- */
-cap_handle_t phone_alloc(task_t *task)
-{
-	cap_handle_t handle = cap_alloc(task);
-	if (handle >= 0) {
-		phone_t *phone = slab_alloc(phone_slab, FRAME_ATOMIC);
-		if (!phone) {
-			cap_free(TASK, handle);
-			return ENOMEM;
+/** Get phone from the current task by ID.
+ *
+ * @param phoneid Phone ID.
+ * @param phone   Place to store pointer to phone.
+ *
+ * @return EOK on success, EINVAL if ID is invalid.
+ *
+ */
+int phone_get(sysarg_t phoneid, phone_t **phone)
+{
+	if (phoneid >= IPC_MAX_PHONES)
+		return EINVAL;
+	
+	*phone = &TASK->phones[phoneid];
+	return EOK;
+}
+
+/** Allocate new phone slot in the specified task.
+ *
+ * @param task Task for which to allocate a new phone.
+ *
+ * @return New phone handle or -1 if the phone handle limit is
+ *         exceeded.
+ *
+ */
+int phone_alloc(task_t *task)
+{
+	irq_spinlock_lock(&task->lock, true);
+	
+	size_t i;
+	for (i = 0; i < IPC_MAX_PHONES; i++) {
+		phone_t *phone = &task->phones[i];
+
+		if ((phone->state == IPC_PHONE_HUNGUP) &&
+		    (atomic_get(&phone->active_calls) == 0))
+			phone->state = IPC_PHONE_FREE;
+		
+		if (phone->state == IPC_PHONE_FREE) {
+			phone->state = IPC_PHONE_CONNECTING;
+			break;
 		}
-		kobject_t *kobject = malloc(sizeof(kobject_t), FRAME_ATOMIC);
-		if (!kobject) {
-			cap_free(TASK, handle);
-			slab_free(phone_slab, phone);
-			return ENOMEM;
-		}
-
-		ipc_phone_init(phone, task);
-		phone->state = IPC_PHONE_CONNECTING;
-
-		kobject_initialize(kobject, KOBJECT_TYPE_PHONE, phone,
-		    &phone_kobject_ops);
-		phone->kobject = kobject;
-		
-		cap_publish(task, handle, kobject);
 	}
 	
-	return handle;
+	irq_spinlock_unlock(&task->lock, true);
+	
+	if (i == IPC_MAX_PHONES)
+		return -1;
+	
+	return i;
+}
+
+/** Mark a phone structure free.
+ *
+ * @param phone Phone structure to be marked free.
+ *
+ */
+static void phone_deallocp(phone_t *phone)
+{
+	assert(phone->state == IPC_PHONE_CONNECTING);
+	
+	/* Atomic operation */
+	phone->state = IPC_PHONE_FREE;
 }
 
@@ -229,36 +230,29 @@
  * All already sent messages will be correctly processed.
  *
- * @param handle Phone capability handle of the phone to be freed.
- *
- */
-void phone_dealloc(cap_handle_t handle)
-{
-	kobject_t *kobj = cap_unpublish(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj)
-		return;
-	
-	assert(kobj->phone);
-	assert(kobj->phone->state == IPC_PHONE_CONNECTING);
-	
-	kobject_put(kobj);
-	cap_free(TASK, handle);
+ * @param phoneid Phone handle of the phone to be freed.
+ *
+ */
+void phone_dealloc(int phoneid)
+{
+	phone_deallocp(&TASK->phones[phoneid]);
 }
 
 /** Connect phone to a given answerbox.
  *
- * @param handle  Capability handle of the phone to be connected.
- * @param box     Answerbox to which to connect the phone.
+ * @param phoneid Phone handle to be connected.
+ * @param box     Answerbox to which to connect the phone handle.
  * @return        True if the phone was connected, false otherwise.
- */
-bool phone_connect(cap_handle_t handle, answerbox_t *box)
-{
-	kobject_t *phone_obj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!phone_obj)
-		return false;
-	
-	assert(phone_obj->phone->state == IPC_PHONE_CONNECTING);
-	
-	/* Hand over phone_obj reference to the answerbox */
-	return ipc_phone_connect(phone_obj->phone, box);
+ *
+ * The procedure _enforces_ that the user first marks the phone
+ * busy (e.g. via phone_alloc) and then connects the phone, otherwise
+ * race condition may appear.
+ *
+ */
+bool phone_connect(int phoneid, answerbox_t *box)
+{
+	phone_t *phone = &TASK->phones[phoneid];
+	
+	assert(phone->state == IPC_PHONE_CONNECTING);
+	return ipc_phone_connect(phone, box);
 }
 
